# settings_func.h File Reference

Functions related to setting/changing the settings. More...

`#include "core/smallvec_type.hpp"`
`#include "company_type.h"`

Go to the source code of this file.

## Typedefs
typedef AutoFreeSmallVector < char *, 4 > | GRFPresetList
## Functions
void | IConsoleSetSetting (const char *name, const char *value, bool force_newgame=false)
void | IConsoleSetSetting (const char *name, int32 value)
void | IConsoleGetSetting (const char *name, bool force_newgame=false)
| Output value of a specific setting to the console.
void | IConsoleListSettings (const char *prefilter)
| List all settings and their value to the console.
void | LoadFromConfig ()
| Load the values from the configuration files.
void | SaveToConfig ()
| Save the values to the configuration file.
void | CheckConfig ()
void | GetGRFPresetList (GRFPresetList *list)
struct GRFConfig * | LoadGRFPresetFromConfig (const char *config_name)
void | SaveGRFPresetToConfig (const char *config_name, struct GRFConfig *config)
void | DeleteGRFPresetFromConfig (const char *config_name)
uint | GetCompanySettingIndex (const char *name)
| Get the index in the _company_settings array of a setting.
void | SetDefaultCompanySettings (CompanyID cid)
| Set the company settings for a new company to their default values.
void | SyncCompanySettings ()
| Sync all company settings in a multiplayer game.

## Detailed Description

Functions related to setting/changing the settings.

Definition in file settings_func.h.

## Function Documentation

uint GetCompanySettingIndex | ( | const char * | name | ) |

Get the index in the _company_settings array of a setting.

Parameters:

  | name | The name of the setting

Returns:
  The index in the _company_settings array

Definition at line 1634 of file settings.cpp.

References SettingDesc::desc, SettingDescBase::flags, GetSettingFromName(), and SGF_PER_COMPANY.

Referenced by AIGroup::EnableWagonRemoval(), ReplaceVehicleWindow::OnClick(), AICompany::SetAutoRenewMoney(), AICompany::SetAutoRenewMonths(), and AICompany::SetAutoRenewStatus().

void IConsoleGetSetting | ( | const char * | name,
|  | bool | force_newgame |
| ) |  |  |

Output value of a specific setting to the console.

Parameters:

  | name | Name of the setting to output its value
  | force_newgame | force the newgame settings

Definition at line 1753 of file settings.cpp.

References SettingDescBase::cmd, SaveLoad::conv, SettingDesc::desc, SettingDescBase::flags, GetSettingFromName(), GetVariableAddress(), IConsolePrintF(), SettingDescBase::max, SettingDescBase::min, ReadValue(), SettingDesc::save, SDT_BOOLX, SDT_STRING, SGF_0ISDISABLED, and SLE_VAR_STRQ.

void IConsoleListSettings | ( | const char * | prefilter | ) |

List all settings and their value to the console.

Parameters:

  | prefilter | If not `NULL`, only list settings with names that begin with prefilter prefix

Definition at line 1786 of file settings.cpp.

References SettingDescBase::cmd, SaveLoad::cmd, SaveLoad::conv, SettingDesc::desc, GetVariableAddress(), IConsolePrintF(), lengthof, SettingDescBase::name, ReadValue(), SettingDesc::save, SDT_BOOLX, SDT_STRING, SLE_VAR_STRQ, SlIsObjectCurrentlyValid(), SaveLoad::version_from, and SaveLoad::version_to.